{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X-}
{$M 8192,0,0}

{ (C) ᮢ .., , 1995 }

Unit Conv;

Interface

Function Value( s : string ) : real;
Function Hex( x : longint ) : string;
Function UnHex( s : string ) : longint;
Function UCase( ch : char ) : char;
Function LCase( ch : char ) : char;

Implementation

Function Value;
var code    : integer;
    x       : real;
begin
     Val(s,x,Code);
     if code>0 then begin
        s:=Copy(s,1,code-1);
        Val(s,x,code);
     end { if };
     Value:=x;
end { Value };

Function UCase;
var b : byte absolute ch;
begin
     case b of
       97..122,160..175 : b:=b-32;
       224..239         : b:=b-80;
     end { select };
     UCase:=Chr(b);
end { UCase };

Function LCase;
var b : byte absolute ch;
begin
     case b of
       65..90,128..143 : b:=b+32;
       144..159        : b:=b+80;
     end { select };
     LCase:=Chr(b);
end { LCase };

Function Hex;
const i  : byte = 8;
      sh : boolean = FALSE;
      sl : boolean = FALSE;
      s  : string[8] = '';
  var hx : array[1..4] of byte absolute x;
     h,l : byte;
begin
     i:=8;
     sh:=FALSE; sl:=sh;
     s:='';
     while i>1 do begin
         h:=hx[i shr 1] shr 4;
         l:=hx[i shr 1] and $F;
         if not sh then sh:=(h>0);
         if not sl then sl:=(l>0) or sh;
         if sh then
           case h of
               0..9 : s:=s+Chr(h+48);
               else   s:=s+Chr(h+55);
           end;
         if sl then
           case l of
               0..9 : s:=s+Chr(l+48);
               else   s:=s+Chr(l+55);
           end;
         Dec(i,2);
     end { while };
     Hex:=s;
end { Hex };

Function UnHex;
var c,l,i : byte;
    uh    : longint;
begin
     l:=Length(s); uh:=0;
     for i:=1 to l do begin
         c:=Ord(s[i]);
         case c of
            48..57 : Inc(uh,c-48);
            65..70 : Inc(uh,c-55);
           97..102 : Inc(uh,c-87);
            0..255 : begin
                          UnHex:=0;
                          Exit;
                     end;
         end { select };
         if i<l then uh:=uh shl 4;
     end { for };
     UnHex:=uh;
end { UnHex };

end.